<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Report\ReportService;

class Tco01202ElaboracaoCardapioDaPropostaRelatorio extends \Zeedhi\Framework\Controller\Report {
    
    protected $reportService; 
    protected $environment; 
    protected $birtStrategy; 
    protected $entityManager; 
    
    public function __construct($reportService, $environment, $birtStrategy, $entityManager) {
        $this->reportService = $reportService; 
        $this->environment = $environment; 
        $this->birtStrategy = $birtStrategy; 
        $this->entityManager = $entityManager; 

    }
    
    protected $reportMapping = array ( 
        'TCO01200' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'          => 'P_DTREFERENCIA',
                        'CDARVPRODINI'          => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'          => 'P_CDARVPRODFIN',
                        'CDPRATOINI'            => 'P_CDPRATOINI',
                        'CDPRATOFIN'            => 'P_CDPRATOFIN',
                        'CDPROPOSTACOMERCIAL'   => 'P_CDPROPOSTACOMERCIAL',
                        'NRORG'                 => 'P_NRORG'
                    )
            ),
        'TCO01201' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'DTREFERENCIA'          => 'P_DTREFERENCIA',
                        'CDARVPRODINI'          => 'P_CDARVPRODINI',
                        'CDARVPRODFIN'          => 'P_CDARVPRODFIN',
                        'CDPRATOINI'            => 'P_CDPRATOINI',
                        'CDPRATOFIN'            => 'P_CDPRATOFIN',
                        'CDPROPOSTACOMERCIAL'   =>'P_CDPROPOSTACOMERCIAL',
                        'NRORG'                 => 'P_NRORG'
                    )
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row["__report_name"] = $row["REPORT_NAME"];
        $row["NRORG"] = $this->environment->getNrorgTrab();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
    
}