<?php
namespace Teknisa\TCO\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\GER\Utilities\Environment;
use Teknisa\GER\Utilities\DataSourceUtil;

class Tco01700TipoPreparoService extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $entityManager;
    protected $crudService;

    public function __construct($crudService, $parameterBag , EntityManager $entityManager, Environment $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->crudService = $crudService;
    }
    
    public function retornaTipoPreparoVinculados($row) {
        $connection = $this->entityManager->getConnection();
        $sql = "SELECT 'TCO01700_USADO_EM_PRATO' AS MESSAGECODE,
                       NMPRATO AS ERRODESC
                  FROM PRATO 
                 WHERE NRTIPOPREPAROTCO = :NRTIPOPREPAROTCO
                   AND NRORG = :NRORG
                   
                 UNION ALL 
                
                SELECT 'TCO01700_USADO_EM_TABELA_CORRECAO' AS MESSAGECODE,
                       NULL AS ERRODESC
                  FROM TABCORRPRODTCO 
                 WHERE NRTIPOPREPAROTCO = :NRTIPOPREPAROTCO
                   AND NRORG = :NRORG
                   
                UNION ALL 
                
                SELECT 'TCO01700_USADO_EM_ITEM_GRAM_CARDAPIO_BASE' AS MESSAGECODE,
                       NULL AS ERRODESC
                  FROM TABCORRPRODTCO 
                 WHERE NRTIPOPREPAROTCO = :NRTIPOPREPAROTCO
                   AND NRORG = :NRORG ";
        
        $query = $connection->prepare($sql);
        
        $params = array(
            'NRTIPOPREPAROTCO' => $row['NRTIPOPREPAROTCO'],
            'NRORG'            => $row['NRORG']
        ); 
        
        $query->execute($params);
        
        $result = $query->fetchAll(\PDO::FETCH_ASSOC);
        
        return $result;
    }
}